      subroutine dali(x,arg,val,y)
*
* four-point lagrange interpolation via interpolating polynomial.
*
      implicit double precision(a-h,o-z)
      dimension arg(1),val(1) 
 
      do 6 j=2,4
        iend=j-1
        do 2 i=1,iend
          h=arg(i)-arg(j)
          val(j)=(val(i)*(x-arg(j))-val(j)*(x-arg(i)))/h
2       continue
6     continue
      y=val(4)
 
      return
      end 

************************************************************************

